#define F_CPU       9600000UL //Частота тактирования контроллера в Гц
#define OUTLED      PB3       //Пин вывода на стробаскоп
#define PulseSensor PB2       //Пин подключения датчика оборотов
#define PulseSenCnt 2         //Количесво импульсов с датчика за один оборот
#define FunParam    9         //Количество лопастей вентилятора

volatile uint32_t Counter_US = 0;   //  Счетчик микросекунд (инкремент на +1 = 10мкс)
uint32_t Counter_Tougle = 0;
uint32_t New_Tougle = 0;
uint32_t CounterTimer_High = 0;
uint32_t CounterTimer_Low = 0;

//Обработчик прерывания таймера по совпадению
ISR(TIM0_COMPA_vect)
{
  Counter_US++;           // Счетчик микросекунд
  Counter_Tougle++;       // Счетчик для обработки переключений строба
  if ((Counter_Tougle<New_Tougle) || (New_Tougle == 0)) return;
  PORTB ^= (1<<OUTLED);   // Переключение вывода подсветки
  Counter_Tougle = 0;     // Обнуление счетчика
}


void setup() 
{  
  DDRB = (1<<OUTLED);                     // Пины на выход
  
  // Настройка таймера в режим СТС (Сброс по совпадению)
  TCCR0A = (1<<WGM01) |(0<<WGM00);        //Установка режима СТС
        
  TCCR0B = (0<<CS02)|(0<<CS01)|(1<<CS00); //Установка предделителя на 1
  TIMSK0 = (1<<OCIE0A);                   //Установка разрешения прерывания по совпадению таймера
  OCR0A =  96;                            // Установка частоты прерываний 100кГц
  
  PORTB |= (1<<OUTLED);                   // включение подсветки по умолчанию
  asm("sei");                             // Глобальное разрешение прерываний
}

void loop() 
{
    while(!(PINB & (1<<PulseSensor)));
    CounterTimer_High = Counter_US;
      while((PINB & (1<<PulseSensor)));
    while(!(PINB & (1<<PulseSensor)));
    CounterTimer_Low = Counter_US;
    
    New_Tougle = (CounterTimer_Low - CounterTimer_High)*PulseSenCnt/(FunParam*2) + 1;
    Counter_US = 0;  
}

